#include <stdio.h>
#include <iostream>

using namespace std;

struct compte 
{
	int numero_compte;
	char nom_titulaire[20], adresse_titulaire[100];
	float solde;
};

compte saisirCompte()
{
	compte tmp; // Variable temporaire permettant de contenir la structure qui sera retournée
	do 
	{
		cout << "Veuillez saisir le numéro de compte\n";
		cin >> tmp.numero_compte;
		if (tmp.numero_compte <= 0)
			cout << "Le numéro de compte doit être positif\n";
	} while(tmp.numero_compte <= 0);
	do 
	{
		cout << "Veuillez saisir le nom du titulaire\n";
		cin >> tmp.nom_titulaire;
		if (tmp.nom_titulaire == "")
			cout << "Le nom ne doit pas être vide\n";
	} while(tmp.nom_titulaire == "");
	do 
	{
		cout << "Veuillez saisir l'adresse du titulaire\n";
		cin >> tmp.adresse_titulaire;
		if (tmp.adresse_titulaire == "")
			cout << "L'adresse ne doit pas être vide\n";
	} while(tmp.adresse_titulaire == "");
	cout << "Veuillez saisir le solde du compte\n";
	cin >> tmp.solde;
	return tmp;	
}

void afficherCompte(compte C)
{
	cout << "Numéro de compte :\t" << C.numero_compte << endl;
	cout << "Nom du titulaire :\t" << C.nom_titulaire << endl;
	cout << "Adresse du titulaire :\t" << C.adresse_titulaire << endl;
	cout << "Solde du compte :\t";// << C.solde << endl;
	printf("%f\n", C.solde);
}

void enregistrerCompte(FILE *f)
{
	compte tmp = saisirCompte();
	fprintf(f, "%d %s %s %f\n", tmp.numero_compte, tmp.nom_titulaire, tmp.adresse_titulaire, tmp.solde);
}

int lireCompte(FILE *f)
{
	int nombre_de_comptes_lus = 0;
	fseek(f, 0, SEEK_SET);
	char c;
	do
	{
		c = fgetc(f);
		if (c == '\n')
			nombre_de_comptes_lus++;
	} while(c != EOF);
	fseek(f, 0, SEEK_SET);
	for (int i = 0; i < nombre_de_comptes_lus; i++)
	{
		compte tmp;
		fscanf(f, "%d %s %s %f\n", &tmp.numero_compte, tmp.nom_titulaire, tmp.adresse_titulaire, &tmp.solde);
		afficherCompte(tmp);
	}
	return nombre_de_comptes_lus;
}

void trierComptesOrdreCroissant(compte *C, int n)
{
	int i, i_max, etape;
	float solde;
	for (etape=1 ; i<n; i++)
	{
		i_max = 0;
		for (i=0 ; i<n-etape; i++)
		{
			if (C[i].solde > C[i_max].solde)
			{
				i_max = i;
			}
			solde = C[i].solde;
			C[i].solde = C[i_max].solde;
			C[i_max].solde = C[i].solde;
		}
	}
}

void trierComptesOrdreCroissant(compte *C, int n)
{
	int i, i_max, etape;
	float solde;
	for (etape=1 ; i<n; i++)
	{
		i_max = 0;
		for (i=0 ; i<n-etape; i++)
		{
			if (C[i].solde > C[i_max].solde)
			{
				i_max = i;
			}
		}
		solde = C[i].solde;
		C[i].solde = C[i_max].solde;
		C[i_max].solde = C[i].solde;
	}
}

int main()
{
	// Test des fonctions de manipulation de la structure compte
/*
	compte mon_compte;
	mon_compte = saisirCompte();
	afficherCompte(mon_compte);
*/

	// Création du fichier "comptes.dat"
	FILE *f;
	char nom_fichier[] = "comptes.dat";
	// Ouverture du fichier en mode ajout ("a") 
	f = fopen(nom_fichier, "a+"); // le "+" derrière le "a" sert à autoriser la lecture

	// Pour plus d'informations sur les modes d'ouverture, tapez dans un terminal "man fopen"

	// On vérifie que le fichier s'est bien ouvert
	if(f == NULL)
	{
		cout << "L'ouverture du fichier 'comptes.dat' a échoué.\n";
		return 1; // On retourne une erreur
	}

	enregistrerCompte(f);

	lireCompte(f);

	fclose(f);
	return 0;
}